; 

    .486
    .model flat, stdcall
    option casemap :none   ; case sensitive

; 

    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\gdi32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\masm32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\masm32.lib

    source_scanner PROTO :DWORD,:DWORD,:DWORD

  .data?
    align 4
    itm00 db 32 dup (?)
    itm01 db 32 dup (?)
    itm02 db 32 dup (?)
    itm03 db 32 dup (?)
    itm04 db 32 dup (?)
    itm05 db 32 dup (?)
    itm06 db 32 dup (?)
    itm07 db 32 dup (?)
    itm08 db 32 dup (?)
    itm09 db 32 dup (?)
    itm0A db 32 dup (?)
    itm0B db 32 dup (?)
    itm0C db 32 dup (?)
    itm0D db 32 dup (?)
    itm0E db 32 dup (?)
    itm0F db 32 dup (?)
    itm10 db 32 dup (?)
    itm11 db 32 dup (?)
    itm12 db 32 dup (?)
    itm13 db 32 dup (?)
    itm14 db 32 dup (?)
    itm15 db 32 dup (?)
    itm16 db 32 dup (?)
    itm17 db 32 dup (?)
    itm18 db 32 dup (?)
    itm19 db 32 dup (?)
    itm1A db 32 dup (?)
    itm1B db 32 dup (?)
    itm1C db 32 dup (?)
    itm1D db 32 dup (?)
    itm1E db 32 dup (?)
    itm1F db 32 dup (?)

.data
    align 4
    tarray dd itm00,itm01,itm02,itm03,itm04,itm05,itm06,itm07
           dd itm08,itm09,itm0A,itm0B,itm0C,itm0D,itm0E,itm0F
           dd itm10,itm11,itm12,itm13,itm14,itm15,itm16,itm17
           dd itm18,itm19,itm1A,itm1B,itm1C,itm1D,itm1E,itm1F

    ;   "   quote       34
    ;   (   lbracket    40
    ;   )   rbracket    41
    ;   *   mul         42
    ;   +   plus        43
    ;   -   minus       45
    ;   .   period      46
    ;   :   semicolon   58
    ;       numbers     48 to 57
    ;   ?   question    63
    ;   @   at symbol   64
    ;       ucase       65 to 90
    ;   [   lsquare     91
    ;   ]   rsquare     93
    ;   _   underscore  95
    ;       lcase       96 to 122

    align 4
    ctable \
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0     ; 15
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0     ; 31
      db 0,0,1,0,0,0,0,0,1,1,1,1,0,1,1,0     ; 47
      db 1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1     ; 63
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1     ; 79
      db 1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1     ; 95
      db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1     ; 111
      db 1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0     ; 127
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


; 

    .code

start:

    call main

    invoke ExitProcess,0

; 

main proc

    LOCAL fname :DWORD
    LOCAL pMem  :DWORD
    LOCAL buffer[260]:BYTE

    mov fname, ptr$(buffer)
    invoke GetCL,1, fname

    mov pMem, InputFile(fname)

    invoke source_scanner,pMem,OFFSET tarray,OFFSET ctable

    free pMem   ; free the source memory

    ret

main endp

; 

show_array proc

    LOCAL str1  :DWORD
    LOCAL hArr  :DWORD
    LOCAL buffer1[512]:BYTE

    push esi

    mov hArr, OFFSET tarray
    mov str1, ptr$(buffer1)

    mov esi, hArr
    mov esi, [esi]
    cmp BYTE PTR [esi], 0   ; don't display empty line
    jne @F
    pop esi
    ret

  @@:
    mov esi, hArr
    mov esi, [esi]
    cmp BYTE PTR [esi], 0
    je @F
    mov str1, cat$(str1,esi,chr$(13,10))
    add hArr, 4
    jmp @B
  @@:

    mov str1, cat$(str1,chr$(13,10))

    invoke StdOut,str1

    pop esi

    ret

show_array endp

; 

source_scanner proc string:DWORD,array:DWORD,table:DWORD

    LOCAL lcflag    :DWORD      ; line continuation flag
    LOCAL zflag     :DWORD      ; flag for ascii zero exit
    LOCAL lparr     :DWORD      ; local array variable

    push ebx
    push esi
    push edi

    mov esi, string
    sub esi, 1
    mov ebx, table
  ; ============================
  restart:
    push array
    pop lparr                   ; copy array address to local
    mov edi, lparr
    mov edi, [edi]              ; 1st string array address
    xor eax, eax                ; prevent stall
  ; ============================
  pre:
    add esi, 1
    cmp BYTE PTR [esi], 32
    je pre
    sub esi, 1
  ; ============================
  sstart:
    add esi, 1
    mov al, [esi]
    cmp al, 0                   ; test end of file
    je iszero
    cmp al, 34                  ; test for leading quote
    je quotes
    cmp BYTE PTR [ebx+eax], 1   ; is char in table ?
    jne presub
  swrite:
    mov [edi], al
    add edi, 1
    jmp sstart
  ; ============================
  align 4
  presub:
    mov BYTE PTR [edi], 0       ; zero terminate arg in array member
  ssublp:
    cmp al, ";"                 ; test for comment
    je commnt
    cmp al, "\"                 ; test for line continuation
    jne @F
    mov lcflag, 1               ; set line continuation flag
  @@:
    cmp al, ","                 ; test for line continuation
    jne @F
    mov lcflag, 1               ; set line continuation flag
  @@:
    cmp al, 10                  ; test end of line condition
    jne @F
    cmp lcflag, 0               ; if flag is clear with ascii
    je setarrend                ; 10 as last char, no further
  @@:                           ; args in source statement
    add esi, 1
    mov al, [esi]
    cmp BYTE PTR [ebx+eax], 1   ; is char in table ?
    jne ssublp

    add lparr, 4
    mov edi, lparr
    mov edi, [edi]
    mov lcflag, 0               ; clear line continuation flag
    sub esi, 1                  ; before jumping back to start
    jmp sstart
  ; ============================
  align 4
  quotes:
    mov [edi], al
    add edi, 1
  subq:
    add esi, 1
    mov al, [esi]
    cmp al, 34
    je swrite
    mov [edi], al
    add edi, 1
    cmp al, 10
    jbe qerror  ; exit on 0 or 10
    jmp subq
  ; ============================
  align 4
  commnt:       ; loop from ; until ascii 10 is read
    add esi, 1
    mov al, [esi]
    cmp al, 0
    je iszero
    cmp al, 10
    jne commnt
    sub esi, 1
    jmp sstart
  ; ============================

  iszero:                       ; end of file condition
    mov zflag, 1

  setarrend:                    ; write a zero in next array
    mov BYTE PTR [edi], 0
    add lparr, 4
    mov edi, lparr              ; to set last item
    mov edi, [edi]
    mov DWORD PTR [edi], 0

  ; -------------------------------------------------------------------------

    call show_array
    cmp zflag, 1
    jne restart

  ; -------------------------------------------------------------------------
    jmp ssexit

  qerror:                       ; non matching quotes
    mov eax, -1

  ssexit: 

    pop edi
    pop esi
    pop ebx

    ret

source_scanner endp

; 

end start